module SetUpDevelopment
  class Installer
    attr_accessor :check_installation_proc,
      :install_proc

    def initialize(check_installation_proc, install_proc)
      self.check_installation_proc = check_installation_proc
      self.install_proc = install_proc
    end

    def installed?(name)
      check_installation_proc.call(name)
    end

    def install!(name)
      install_proc.call(name)
    end
  end
end
